# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['HttpRouteArgs', 'HttpRoute']

@pulumi.input_type
class HttpRouteArgs:
    def __init__(__self__, *,
                 hostnames: pulumi.Input[Sequence[pulumi.Input[str]]],
                 rules: pulumi.Input[Sequence[pulumi.Input['HttpRouteRuleArgs']]],
                 description: Optional[pulumi.Input[str]] = None,
                 gateways: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 meshes: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a HttpRoute resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] hostnames: Set of hosts that should match against the HTTP host header to select a HttpRoute to process the request.
        :param pulumi.Input[Sequence[pulumi.Input['HttpRouteRuleArgs']]] rules: Rules that define how traffic is routed and handled.
               Structure is documented below.
        :param pulumi.Input[str] description: A free-text description of the resource. Max length 1024 characters.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] gateways: Gateways defines a list of gateways this HttpRoute is attached to, as one of the routing rules to route the requests
               served by the gateway. Each gateway reference should match the pattern:
               projects/*/locations/global/gateways/<gateway_name>
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: Set of label tags associated with the HttpRoute resource. **Note**: This field is non-authoritative, and will only
               manage the labels present in your configuration. Please refer to the field 'effective_labels' for all of the labels
               present on the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] meshes: Meshes defines a list of meshes this HttpRoute is attached to, as one of the routing rules to route the requests served
               by the mesh. Each mesh reference should match the pattern: projects/*/locations/global/meshes/<mesh_name>. The attached
               Mesh should be of a type SIDECAR.
        :param pulumi.Input[str] name: Name of the HttpRoute resource.
        """
        pulumi.set(__self__, "hostnames", hostnames)
        pulumi.set(__self__, "rules", rules)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if gateways is not None:
            pulumi.set(__self__, "gateways", gateways)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if meshes is not None:
            pulumi.set(__self__, "meshes", meshes)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if project is not None:
            pulumi.set(__self__, "project", project)

    @property
    @pulumi.getter
    def hostnames(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Set of hosts that should match against the HTTP host header to select a HttpRoute to process the request.
        """
        return pulumi.get(self, "hostnames")

    @hostnames.setter
    def hostnames(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "hostnames", value)

    @property
    @pulumi.getter
    def rules(self) -> pulumi.Input[Sequence[pulumi.Input['HttpRouteRuleArgs']]]:
        """
        Rules that define how traffic is routed and handled.
        Structure is documented below.
        """
        return pulumi.get(self, "rules")

    @rules.setter
    def rules(self, value: pulumi.Input[Sequence[pulumi.Input['HttpRouteRuleArgs']]]):
        pulumi.set(self, "rules", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        A free-text description of the resource. Max length 1024 characters.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def gateways(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Gateways defines a list of gateways this HttpRoute is attached to, as one of the routing rules to route the requests
        served by the gateway. Each gateway reference should match the pattern:
        projects/*/locations/global/gateways/<gateway_name>
        """
        return pulumi.get(self, "gateways")

    @gateways.setter
    def gateways(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "gateways", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Set of label tags associated with the HttpRoute resource. **Note**: This field is non-authoritative, and will only
        manage the labels present in your configuration. Please refer to the field 'effective_labels' for all of the labels
        present on the resource.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def meshes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Meshes defines a list of meshes this HttpRoute is attached to, as one of the routing rules to route the requests served
        by the mesh. Each mesh reference should match the pattern: projects/*/locations/global/meshes/<mesh_name>. The attached
        Mesh should be of a type SIDECAR.
        """
        return pulumi.get(self, "meshes")

    @meshes.setter
    def meshes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "meshes", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the HttpRoute resource.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project", value)


@pulumi.input_type
class _HttpRouteState:
    def __init__(__self__, *,
                 create_time: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 effective_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 gateways: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 hostnames: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 meshes: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 pulumi_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input['HttpRouteRuleArgs']]]] = None,
                 self_link: Optional[pulumi.Input[str]] = None,
                 update_time: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering HttpRoute resources.
        :param pulumi.Input[str] create_time: Time the HttpRoute was created in UTC.
        :param pulumi.Input[str] description: A free-text description of the resource. Max length 1024 characters.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] effective_labels: All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] gateways: Gateways defines a list of gateways this HttpRoute is attached to, as one of the routing rules to route the requests
               served by the gateway. Each gateway reference should match the pattern:
               projects/*/locations/global/gateways/<gateway_name>
        :param pulumi.Input[Sequence[pulumi.Input[str]]] hostnames: Set of hosts that should match against the HTTP host header to select a HttpRoute to process the request.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: Set of label tags associated with the HttpRoute resource. **Note**: This field is non-authoritative, and will only
               manage the labels present in your configuration. Please refer to the field 'effective_labels' for all of the labels
               present on the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] meshes: Meshes defines a list of meshes this HttpRoute is attached to, as one of the routing rules to route the requests served
               by the mesh. Each mesh reference should match the pattern: projects/*/locations/global/meshes/<mesh_name>. The attached
               Mesh should be of a type SIDECAR.
        :param pulumi.Input[str] name: Name of the HttpRoute resource.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] pulumi_labels: The combination of labels configured directly on the resource
               and default labels configured on the provider.
        :param pulumi.Input[Sequence[pulumi.Input['HttpRouteRuleArgs']]] rules: Rules that define how traffic is routed and handled.
               Structure is documented below.
        :param pulumi.Input[str] self_link: Server-defined URL of this resource.
        :param pulumi.Input[str] update_time: Time the HttpRoute was updated in UTC.
        """
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if effective_labels is not None:
            pulumi.set(__self__, "effective_labels", effective_labels)
        if gateways is not None:
            pulumi.set(__self__, "gateways", gateways)
        if hostnames is not None:
            pulumi.set(__self__, "hostnames", hostnames)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if meshes is not None:
            pulumi.set(__self__, "meshes", meshes)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if pulumi_labels is not None:
            pulumi.set(__self__, "pulumi_labels", pulumi_labels)
        if rules is not None:
            pulumi.set(__self__, "rules", rules)
        if self_link is not None:
            pulumi.set(__self__, "self_link", self_link)
        if update_time is not None:
            pulumi.set(__self__, "update_time", update_time)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[str]]:
        """
        Time the HttpRoute was created in UTC.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        A free-text description of the resource. Max length 1024 characters.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="effectiveLabels")
    def effective_labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        """
        return pulumi.get(self, "effective_labels")

    @effective_labels.setter
    def effective_labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "effective_labels", value)

    @property
    @pulumi.getter
    def gateways(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Gateways defines a list of gateways this HttpRoute is attached to, as one of the routing rules to route the requests
        served by the gateway. Each gateway reference should match the pattern:
        projects/*/locations/global/gateways/<gateway_name>
        """
        return pulumi.get(self, "gateways")

    @gateways.setter
    def gateways(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "gateways", value)

    @property
    @pulumi.getter
    def hostnames(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Set of hosts that should match against the HTTP host header to select a HttpRoute to process the request.
        """
        return pulumi.get(self, "hostnames")

    @hostnames.setter
    def hostnames(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "hostnames", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Set of label tags associated with the HttpRoute resource. **Note**: This field is non-authoritative, and will only
        manage the labels present in your configuration. Please refer to the field 'effective_labels' for all of the labels
        present on the resource.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def meshes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Meshes defines a list of meshes this HttpRoute is attached to, as one of the routing rules to route the requests served
        by the mesh. Each mesh reference should match the pattern: projects/*/locations/global/meshes/<mesh_name>. The attached
        Mesh should be of a type SIDECAR.
        """
        return pulumi.get(self, "meshes")

    @meshes.setter
    def meshes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "meshes", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the HttpRoute resource.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter(name="pulumiLabels")
    def pulumi_labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The combination of labels configured directly on the resource
        and default labels configured on the provider.
        """
        return pulumi.get(self, "pulumi_labels")

    @pulumi_labels.setter
    def pulumi_labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "pulumi_labels", value)

    @property
    @pulumi.getter
    def rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['HttpRouteRuleArgs']]]]:
        """
        Rules that define how traffic is routed and handled.
        Structure is documented below.
        """
        return pulumi.get(self, "rules")

    @rules.setter
    def rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['HttpRouteRuleArgs']]]]):
        pulumi.set(self, "rules", value)

    @property
    @pulumi.getter(name="selfLink")
    def self_link(self) -> Optional[pulumi.Input[str]]:
        """
        Server-defined URL of this resource.
        """
        return pulumi.get(self, "self_link")

    @self_link.setter
    def self_link(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "self_link", value)

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> Optional[pulumi.Input[str]]:
        """
        Time the HttpRoute was updated in UTC.
        """
        return pulumi.get(self, "update_time")

    @update_time.setter
    def update_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "update_time", value)


class HttpRoute(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 gateways: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 hostnames: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 meshes: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['HttpRouteRuleArgs', 'HttpRouteRuleArgsDict']]]]] = None,
                 __props__=None):
        """
        ## Example Usage

        ### Network Services Http Route Basic

        ```python
        import pulumi
        import pulumi_gcp as gcp

        default = gcp.networkservices.HttpRoute("default",
            name="my-http-route",
            labels={
                "foo": "bar",
            },
            description="my description",
            hostnames=["example"],
            rules=[{
                "matches": [{
                    "queryParameters": [{
                        "queryParameter": "key",
                        "exactMatch": "value",
                    }],
                    "fullPathMatch": "example",
                }],
            }])
        ```
        ### Network Services Http Route Matches And Actions

        ```python
        import pulumi
        import pulumi_gcp as gcp

        default = gcp.networkservices.HttpRoute("default",
            name="my-http-route",
            labels={
                "foo": "bar",
            },
            description="my description",
            hostnames=["example"],
            rules=[{
                "matches": [
                    {
                        "headers": [{
                            "header": "header",
                            "invertMatch": False,
                            "regexMatch": "header-value",
                        }],
                        "queryParameters": [{
                            "queryParameter": "key",
                            "exactMatch": "value",
                        }],
                        "prefixMatch": "example",
                        "ignoreCase": False,
                    },
                    {
                        "headers": [{
                            "header": "header",
                            "invertMatch": False,
                            "presentMatch": True,
                        }],
                        "queryParameters": [{
                            "queryParameter": "key",
                            "regexMatch": "value",
                        }],
                        "regexMatch": "example",
                        "ignoreCase": False,
                    },
                    {
                        "headers": [{
                            "header": "header",
                            "invertMatch": False,
                            "presentMatch": True,
                        }],
                        "queryParameters": [{
                            "queryParameter": "key",
                            "presentMatch": True,
                        }],
                        "fullPathMatch": "example",
                        "ignoreCase": False,
                    },
                ],
                "action": {
                    "redirect": {
                        "hostRedirect": "new-host",
                        "pathRedirect": "new-path",
                        "prefixRewrite": "new-prefix",
                        "httpsRedirect": True,
                        "stripQuery": True,
                        "portRedirect": 8081,
                    },
                    "urlRewrite": {
                        "pathPrefixRewrite": "new-prefix",
                        "hostRewrite": "new-host",
                    },
                    "retryPolicy": {
                        "retryConditions": ["server_error"],
                        "numRetries": 1,
                        "perTryTimeout": "1s",
                    },
                    "requestMirrorPolicy": {
                        "destination": {
                            "serviceName": "new",
                            "weight": 1,
                        },
                    },
                    "corsPolicy": {
                        "allowOrigins": ["example"],
                        "allowMethods": [
                            "GET",
                            "PUT",
                        ],
                        "allowHeaders": [
                            "version",
                            "type",
                        ],
                        "exposeHeaders": [
                            "version",
                            "type",
                        ],
                        "maxAge": "1s",
                        "allowCredentials": True,
                        "disabled": False,
                    },
                },
            }])
        ```
        ### Network Services Http Route Actions

        ```python
        import pulumi
        import pulumi_gcp as gcp

        default = gcp.networkservices.HttpRoute("default",
            name="my-http-route",
            labels={
                "foo": "bar",
            },
            description="my description",
            hostnames=["example"],
            rules=[{
                "action": {
                    "faultInjectionPolicy": {
                        "delay": {
                            "fixedDelay": "1s",
                            "percentage": 1,
                        },
                        "abort": {
                            "httpStatus": 500,
                            "percentage": 1,
                        },
                    },
                    "urlRewrite": {
                        "pathPrefixRewrite": "new-prefix",
                        "hostRewrite": "new-host",
                    },
                    "retryPolicy": {
                        "retryConditions": ["server_error"],
                        "numRetries": 1,
                        "perTryTimeout": "1s",
                    },
                    "requestMirrorPolicy": {
                        "destination": {
                            "serviceName": "new",
                            "weight": 1,
                        },
                    },
                    "corsPolicy": {
                        "allowOrigins": ["example"],
                        "allowMethods": [
                            "GET",
                            "PUT",
                        ],
                        "allowHeaders": [
                            "version",
                            "type",
                        ],
                        "exposeHeaders": [
                            "version",
                            "type",
                        ],
                        "maxAge": "1s",
                        "allowCredentials": True,
                        "disabled": False,
                    },
                    "requestHeaderModifier": {
                        "set": {
                            "version": "1",
                            "type": "json",
                        },
                        "add": {
                            "minor-version": "1",
                        },
                        "removes": ["arg"],
                    },
                    "responseHeaderModifier": {
                        "set": {
                            "version": "1",
                            "type": "json",
                        },
                        "add": {
                            "minor-version": "1",
                        },
                        "removes": ["removearg"],
                    },
                },
            }])
        ```
        ### Network Services Http Route Mesh Basic

        ```python
        import pulumi
        import pulumi_gcp as gcp

        default = gcp.networkservices.Mesh("default",
            name="my-http-route",
            labels={
                "foo": "bar",
            },
            description="my description")
        default_http_route = gcp.networkservices.HttpRoute("default",
            name="my-http-route",
            labels={
                "foo": "bar",
            },
            description="my description",
            hostnames=["example"],
            meshes=[default.id],
            rules=[{
                "matches": [{
                    "queryParameters": [{
                        "queryParameter": "key",
                        "exactMatch": "value",
                    }],
                    "fullPathMatch": "example",
                }],
            }])
        ```

        ## Import

        HttpRoute can be imported using any of these accepted formats:

        * `projects/{{project}}/locations/global/httpRoutes/{{name}}`

        * `{{project}}/{{name}}`

        * `{{name}}`

        When using the `pulumi import` command, HttpRoute can be imported using one of the formats above. For example:

        ```sh
        $ pulumi import gcp:networkservices/httpRoute:HttpRoute default projects/{{project}}/locations/global/httpRoutes/{{name}}
        ```

        ```sh
        $ pulumi import gcp:networkservices/httpRoute:HttpRoute default {{project}}/{{name}}
        ```

        ```sh
        $ pulumi import gcp:networkservices/httpRoute:HttpRoute default {{name}}
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: A free-text description of the resource. Max length 1024 characters.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] gateways: Gateways defines a list of gateways this HttpRoute is attached to, as one of the routing rules to route the requests
               served by the gateway. Each gateway reference should match the pattern:
               projects/*/locations/global/gateways/<gateway_name>
        :param pulumi.Input[Sequence[pulumi.Input[str]]] hostnames: Set of hosts that should match against the HTTP host header to select a HttpRoute to process the request.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: Set of label tags associated with the HttpRoute resource. **Note**: This field is non-authoritative, and will only
               manage the labels present in your configuration. Please refer to the field 'effective_labels' for all of the labels
               present on the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] meshes: Meshes defines a list of meshes this HttpRoute is attached to, as one of the routing rules to route the requests served
               by the mesh. Each mesh reference should match the pattern: projects/*/locations/global/meshes/<mesh_name>. The attached
               Mesh should be of a type SIDECAR.
        :param pulumi.Input[str] name: Name of the HttpRoute resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['HttpRouteRuleArgs', 'HttpRouteRuleArgsDict']]]] rules: Rules that define how traffic is routed and handled.
               Structure is documented below.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: HttpRouteArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ### Network Services Http Route Basic

        ```python
        import pulumi
        import pulumi_gcp as gcp

        default = gcp.networkservices.HttpRoute("default",
            name="my-http-route",
            labels={
                "foo": "bar",
            },
            description="my description",
            hostnames=["example"],
            rules=[{
                "matches": [{
                    "queryParameters": [{
                        "queryParameter": "key",
                        "exactMatch": "value",
                    }],
                    "fullPathMatch": "example",
                }],
            }])
        ```
        ### Network Services Http Route Matches And Actions

        ```python
        import pulumi
        import pulumi_gcp as gcp

        default = gcp.networkservices.HttpRoute("default",
            name="my-http-route",
            labels={
                "foo": "bar",
            },
            description="my description",
            hostnames=["example"],
            rules=[{
                "matches": [
                    {
                        "headers": [{
                            "header": "header",
                            "invertMatch": False,
                            "regexMatch": "header-value",
                        }],
                        "queryParameters": [{
                            "queryParameter": "key",
                            "exactMatch": "value",
                        }],
                        "prefixMatch": "example",
                        "ignoreCase": False,
                    },
                    {
                        "headers": [{
                            "header": "header",
                            "invertMatch": False,
                            "presentMatch": True,
                        }],
                        "queryParameters": [{
                            "queryParameter": "key",
                            "regexMatch": "value",
                        }],
                        "regexMatch": "example",
                        "ignoreCase": False,
                    },
                    {
                        "headers": [{
                            "header": "header",
                            "invertMatch": False,
                            "presentMatch": True,
                        }],
                        "queryParameters": [{
                            "queryParameter": "key",
                            "presentMatch": True,
                        }],
                        "fullPathMatch": "example",
                        "ignoreCase": False,
                    },
                ],
                "action": {
                    "redirect": {
                        "hostRedirect": "new-host",
                        "pathRedirect": "new-path",
                        "prefixRewrite": "new-prefix",
                        "httpsRedirect": True,
                        "stripQuery": True,
                        "portRedirect": 8081,
                    },
                    "urlRewrite": {
                        "pathPrefixRewrite": "new-prefix",
                        "hostRewrite": "new-host",
                    },
                    "retryPolicy": {
                        "retryConditions": ["server_error"],
                        "numRetries": 1,
                        "perTryTimeout": "1s",
                    },
                    "requestMirrorPolicy": {
                        "destination": {
                            "serviceName": "new",
                            "weight": 1,
                        },
                    },
                    "corsPolicy": {
                        "allowOrigins": ["example"],
                        "allowMethods": [
                            "GET",
                            "PUT",
                        ],
                        "allowHeaders": [
                            "version",
                            "type",
                        ],
                        "exposeHeaders": [
                            "version",
                            "type",
                        ],
                        "maxAge": "1s",
                        "allowCredentials": True,
                        "disabled": False,
                    },
                },
            }])
        ```
        ### Network Services Http Route Actions

        ```python
        import pulumi
        import pulumi_gcp as gcp

        default = gcp.networkservices.HttpRoute("default",
            name="my-http-route",
            labels={
                "foo": "bar",
            },
            description="my description",
            hostnames=["example"],
            rules=[{
                "action": {
                    "faultInjectionPolicy": {
                        "delay": {
                            "fixedDelay": "1s",
                            "percentage": 1,
                        },
                        "abort": {
                            "httpStatus": 500,
                            "percentage": 1,
                        },
                    },
                    "urlRewrite": {
                        "pathPrefixRewrite": "new-prefix",
                        "hostRewrite": "new-host",
                    },
                    "retryPolicy": {
                        "retryConditions": ["server_error"],
                        "numRetries": 1,
                        "perTryTimeout": "1s",
                    },
                    "requestMirrorPolicy": {
                        "destination": {
                            "serviceName": "new",
                            "weight": 1,
                        },
                    },
                    "corsPolicy": {
                        "allowOrigins": ["example"],
                        "allowMethods": [
                            "GET",
                            "PUT",
                        ],
                        "allowHeaders": [
                            "version",
                            "type",
                        ],
                        "exposeHeaders": [
                            "version",
                            "type",
                        ],
                        "maxAge": "1s",
                        "allowCredentials": True,
                        "disabled": False,
                    },
                    "requestHeaderModifier": {
                        "set": {
                            "version": "1",
                            "type": "json",
                        },
                        "add": {
                            "minor-version": "1",
                        },
                        "removes": ["arg"],
                    },
                    "responseHeaderModifier": {
                        "set": {
                            "version": "1",
                            "type": "json",
                        },
                        "add": {
                            "minor-version": "1",
                        },
                        "removes": ["removearg"],
                    },
                },
            }])
        ```
        ### Network Services Http Route Mesh Basic

        ```python
        import pulumi
        import pulumi_gcp as gcp

        default = gcp.networkservices.Mesh("default",
            name="my-http-route",
            labels={
                "foo": "bar",
            },
            description="my description")
        default_http_route = gcp.networkservices.HttpRoute("default",
            name="my-http-route",
            labels={
                "foo": "bar",
            },
            description="my description",
            hostnames=["example"],
            meshes=[default.id],
            rules=[{
                "matches": [{
                    "queryParameters": [{
                        "queryParameter": "key",
                        "exactMatch": "value",
                    }],
                    "fullPathMatch": "example",
                }],
            }])
        ```

        ## Import

        HttpRoute can be imported using any of these accepted formats:

        * `projects/{{project}}/locations/global/httpRoutes/{{name}}`

        * `{{project}}/{{name}}`

        * `{{name}}`

        When using the `pulumi import` command, HttpRoute can be imported using one of the formats above. For example:

        ```sh
        $ pulumi import gcp:networkservices/httpRoute:HttpRoute default projects/{{project}}/locations/global/httpRoutes/{{name}}
        ```

        ```sh
        $ pulumi import gcp:networkservices/httpRoute:HttpRoute default {{project}}/{{name}}
        ```

        ```sh
        $ pulumi import gcp:networkservices/httpRoute:HttpRoute default {{name}}
        ```

        :param str resource_name: The name of the resource.
        :param HttpRouteArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(HttpRouteArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 gateways: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 hostnames: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 meshes: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['HttpRouteRuleArgs', 'HttpRouteRuleArgsDict']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = HttpRouteArgs.__new__(HttpRouteArgs)

            __props__.__dict__["description"] = description
            __props__.__dict__["gateways"] = gateways
            if hostnames is None and not opts.urn:
                raise TypeError("Missing required property 'hostnames'")
            __props__.__dict__["hostnames"] = hostnames
            __props__.__dict__["labels"] = labels
            __props__.__dict__["meshes"] = meshes
            __props__.__dict__["name"] = name
            __props__.__dict__["project"] = project
            if rules is None and not opts.urn:
                raise TypeError("Missing required property 'rules'")
            __props__.__dict__["rules"] = rules
            __props__.__dict__["create_time"] = None
            __props__.__dict__["effective_labels"] = None
            __props__.__dict__["pulumi_labels"] = None
            __props__.__dict__["self_link"] = None
            __props__.__dict__["update_time"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["effectiveLabels", "pulumiLabels"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(HttpRoute, __self__).__init__(
            'gcp:networkservices/httpRoute:HttpRoute',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            create_time: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            effective_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            gateways: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            hostnames: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            meshes: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            project: Optional[pulumi.Input[str]] = None,
            pulumi_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['HttpRouteRuleArgs', 'HttpRouteRuleArgsDict']]]]] = None,
            self_link: Optional[pulumi.Input[str]] = None,
            update_time: Optional[pulumi.Input[str]] = None) -> 'HttpRoute':
        """
        Get an existing HttpRoute resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] create_time: Time the HttpRoute was created in UTC.
        :param pulumi.Input[str] description: A free-text description of the resource. Max length 1024 characters.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] effective_labels: All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] gateways: Gateways defines a list of gateways this HttpRoute is attached to, as one of the routing rules to route the requests
               served by the gateway. Each gateway reference should match the pattern:
               projects/*/locations/global/gateways/<gateway_name>
        :param pulumi.Input[Sequence[pulumi.Input[str]]] hostnames: Set of hosts that should match against the HTTP host header to select a HttpRoute to process the request.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: Set of label tags associated with the HttpRoute resource. **Note**: This field is non-authoritative, and will only
               manage the labels present in your configuration. Please refer to the field 'effective_labels' for all of the labels
               present on the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] meshes: Meshes defines a list of meshes this HttpRoute is attached to, as one of the routing rules to route the requests served
               by the mesh. Each mesh reference should match the pattern: projects/*/locations/global/meshes/<mesh_name>. The attached
               Mesh should be of a type SIDECAR.
        :param pulumi.Input[str] name: Name of the HttpRoute resource.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] pulumi_labels: The combination of labels configured directly on the resource
               and default labels configured on the provider.
        :param pulumi.Input[Sequence[pulumi.Input[Union['HttpRouteRuleArgs', 'HttpRouteRuleArgsDict']]]] rules: Rules that define how traffic is routed and handled.
               Structure is documented below.
        :param pulumi.Input[str] self_link: Server-defined URL of this resource.
        :param pulumi.Input[str] update_time: Time the HttpRoute was updated in UTC.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _HttpRouteState.__new__(_HttpRouteState)

        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["description"] = description
        __props__.__dict__["effective_labels"] = effective_labels
        __props__.__dict__["gateways"] = gateways
        __props__.__dict__["hostnames"] = hostnames
        __props__.__dict__["labels"] = labels
        __props__.__dict__["meshes"] = meshes
        __props__.__dict__["name"] = name
        __props__.__dict__["project"] = project
        __props__.__dict__["pulumi_labels"] = pulumi_labels
        __props__.__dict__["rules"] = rules
        __props__.__dict__["self_link"] = self_link
        __props__.__dict__["update_time"] = update_time
        return HttpRoute(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[str]:
        """
        Time the HttpRoute was created in UTC.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        A free-text description of the resource. Max length 1024 characters.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="effectiveLabels")
    def effective_labels(self) -> pulumi.Output[Mapping[str, str]]:
        """
        All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        """
        return pulumi.get(self, "effective_labels")

    @property
    @pulumi.getter
    def gateways(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Gateways defines a list of gateways this HttpRoute is attached to, as one of the routing rules to route the requests
        served by the gateway. Each gateway reference should match the pattern:
        projects/*/locations/global/gateways/<gateway_name>
        """
        return pulumi.get(self, "gateways")

    @property
    @pulumi.getter
    def hostnames(self) -> pulumi.Output[Sequence[str]]:
        """
        Set of hosts that should match against the HTTP host header to select a HttpRoute to process the request.
        """
        return pulumi.get(self, "hostnames")

    @property
    @pulumi.getter
    def labels(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Set of label tags associated with the HttpRoute resource. **Note**: This field is non-authoritative, and will only
        manage the labels present in your configuration. Please refer to the field 'effective_labels' for all of the labels
        present on the resource.
        """
        return pulumi.get(self, "labels")

    @property
    @pulumi.getter
    def meshes(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Meshes defines a list of meshes this HttpRoute is attached to, as one of the routing rules to route the requests served
        by the mesh. Each mesh reference should match the pattern: projects/*/locations/global/meshes/<mesh_name>. The attached
        Mesh should be of a type SIDECAR.
        """
        return pulumi.get(self, "meshes")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of the HttpRoute resource.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def project(self) -> pulumi.Output[str]:
        return pulumi.get(self, "project")

    @property
    @pulumi.getter(name="pulumiLabels")
    def pulumi_labels(self) -> pulumi.Output[Mapping[str, str]]:
        """
        The combination of labels configured directly on the resource
        and default labels configured on the provider.
        """
        return pulumi.get(self, "pulumi_labels")

    @property
    @pulumi.getter
    def rules(self) -> pulumi.Output[Sequence['outputs.HttpRouteRule']]:
        """
        Rules that define how traffic is routed and handled.
        Structure is documented below.
        """
        return pulumi.get(self, "rules")

    @property
    @pulumi.getter(name="selfLink")
    def self_link(self) -> pulumi.Output[str]:
        """
        Server-defined URL of this resource.
        """
        return pulumi.get(self, "self_link")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> pulumi.Output[str]:
        """
        Time the HttpRoute was updated in UTC.
        """
        return pulumi.get(self, "update_time")

